Bug 1654761 - Backport "tc: f_flower: add geneve option match support to flower"
Summary: Backport "tc: f_flower: add geneve option match support to flower"
Keywords:
Status: CLOSED CURRENTRELEASE
Alias: None
Product: Red Hat Enterprise Linux 8
Classification: Red Hat
Component: iproute
Version: 8.0
Hardware: Unspecified
OS: Unspecified
medium
medium
Target Milestone: rc
: 8.0
Assignee: Andrea Claudi
QA Contact: Jaroslav Aster
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2018-11-29 15:39 UTC by Pablo Cascon (Netronome)
Modified: 2019-06-14 01:19 UTC (History)
7 users (show)

Fixed In Version: iproute-4.18.0-11.el8
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2019-06-14 01:19:38 UTC
Type: Bug
Target Upstream Version:


Attachments (Terms of Use)

Description Pablo Cascon (Netronome) 2018-11-29 15:39:36 UTC
Please backport:

commit 56155d4df86d489c4207444c8a90ce4e0e22e49f
Author: Pieter Jansen van Vuuren <pieter.jansenvanvuuren@netronome.com>
Date:   Fri Sep 28 16:03:39 2018 +0200

    tc: f_flower: add geneve option match support to flower
    
    Allow matching on options in Geneve tunnel headers.
    
    The options can be described in the form
    CLASS:TYPE:DATA/CLASS_MASK:TYPE_MASK:DATA_MASK, where CLASS is
    represented as a 16bit hexadecimal value, TYPE as an 8bit
    hexadecimal value and DATA as a variable length hexadecimal value.
    
    e.g.
     # ip link add name geneve0 type geneve dstport 0 external
     # tc qdisc add dev geneve0 ingress
     # tc filter add dev geneve0 protocol ip parent ffff: \
         flower \
           enc_src_ip 10.0.99.192 \
           enc_dst_ip 10.0.99.193 \
           enc_key_id 11 \
           geneve_opts 0102:80:1122334421314151/ffff:ff:ffffffffffffffff \
           ip_proto udp \
           action mirred egress redirect dev eth1
    
    Signed-off-by: Pieter Jansen van Vuuren <pieter.jansenvanvuuren@netronome.com>
    Signed-off-by: Simon Horman <simon.horman@netronome.com>
    Signed-off-by: David Ahern <dsahern@gmail.com>

Comment 1 Pablo Cascon (Netronome) 2018-11-29 15:54:02 UTC
Happy to try backporting and propose patches for the iproute pkg

Comment 2 Phil Sutter 2018-12-03 10:35:39 UTC
Hi Pablo,

(In reply to Pablo Cascon from comment #1)
> Happy to try backporting and propose patches for the iproute pkg

Thanks for your offer, shouldn't be necessary though. RHEL8 iproute is pretty up to date, so backporting should be easy. I'd appreciate though if you could give it a quick test once a build containing the requested patch is available (I'll update the Fixed In Version field then).

Thanks, Phil

Comment 3 Pablo Cascon (Netronome) 2018-12-03 10:56:28 UTC
Hello Phil,

brilliant. Absolutely will get it tested.

Have gone half way to create a custom iproute pkg just to realize we also need:

6217917 tc: m_tunnel_key: Add tunnel option support to act_tunnel_key

and deps as it doesn't apply nicely unfortunately. Sorry about that, let me know if you wanted a different BZ. Will try to figure the list of deps and post them here.

Thanks, Pablo

Comment 4 Jaroslav Aster 2019-01-07 14:56:13 UTC
Hi Pablo,

do you have any justification why this is needed in 8.0.0.0 and it can not wait for 8.1.0.0?

Comment 5 Pablo Cascon (Netronome) 2019-01-07 15:57:33 UTC
Hello Jaroslav, not a strong one, it is a very nice to have, specially for debugging and also for testing the driver feature backported in 1655604 without OVS. It is mostly that all the dev work has been done and the backport is the last step :) Happy to get this backport tested by Netronome

Comment 6 Jaroslav Aster 2019-01-07 16:13:39 UTC
If someone else (Netronome) verify this bug, I'm ok with it. Setting qa_ack. Anyway it needs exception from PM.

Comment 12 Pablo Cascon (Netronome) 2019-02-05 15:57:15 UTC
Pkg iproute-4.18.0-11.el8 works as expected, this is verified from Netronome side, please consider marking this BZ as qa_ack+


Note You need to log in before you can comment on or make changes to this bug.